// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListAccountRolesOutput {
    /// <p>The page token client that is used to retrieve the list of accounts.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    /// <p>A paginated response with the list of roles and the next token if more results are available.</p>
    pub role_list: ::std::option::Option<::std::vec::Vec<crate::types::RoleInfo>>,
    _request_id: Option<String>,
}
impl ListAccountRolesOutput {
    /// <p>The page token client that is used to retrieve the list of accounts.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
    /// <p>A paginated response with the list of roles and the next token if more results are available.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.role_list.is_none()`.
    pub fn role_list(&self) -> &[crate::types::RoleInfo] {
        self.role_list.as_deref().unwrap_or_default()
    }
}
impl ::aws_types::request_id::RequestId for ListAccountRolesOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListAccountRolesOutput {
    /// Creates a new builder-style object to manufacture [`ListAccountRolesOutput`](crate::operation::list_account_roles::ListAccountRolesOutput).
    pub fn builder() -> crate::operation::list_account_roles::builders::ListAccountRolesOutputBuilder {
        crate::operation::list_account_roles::builders::ListAccountRolesOutputBuilder::default()
    }
}

/// A builder for [`ListAccountRolesOutput`](crate::operation::list_account_roles::ListAccountRolesOutput).
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
#[non_exhaustive]
pub struct ListAccountRolesOutputBuilder {
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    pub(crate) role_list: ::std::option::Option<::std::vec::Vec<crate::types::RoleInfo>>,
    _request_id: Option<String>,
}
impl ListAccountRolesOutputBuilder {
    /// <p>The page token client that is used to retrieve the list of accounts.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The page token client that is used to retrieve the list of accounts.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>The page token client that is used to retrieve the list of accounts.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    /// Appends an item to `role_list`.
    ///
    /// To override the contents of this collection use [`set_role_list`](Self::set_role_list).
    ///
    /// <p>A paginated response with the list of roles and the next token if more results are available.</p>
    pub fn role_list(mut self, input: crate::types::RoleInfo) -> Self {
        let mut v = self.role_list.unwrap_or_default();
        v.push(input);
        self.role_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>A paginated response with the list of roles and the next token if more results are available.</p>
    pub fn set_role_list(mut self, input: ::std::option::Option<::std::vec::Vec<crate::types::RoleInfo>>) -> Self {
        self.role_list = input;
        self
    }
    /// <p>A paginated response with the list of roles and the next token if more results are available.</p>
    pub fn get_role_list(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::RoleInfo>> {
        &self.role_list
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListAccountRolesOutput`](crate::operation::list_account_roles::ListAccountRolesOutput).
    pub fn build(self) -> crate::operation::list_account_roles::ListAccountRolesOutput {
        crate::operation::list_account_roles::ListAccountRolesOutput {
            next_token: self.next_token,
            role_list: self.role_list,
            _request_id: self._request_id,
        }
    }
}
