pub(super) static VERSION: Option<&str> = Some(r"2025b");

pub(super) static TZNAME_TO_OFFSET: &[(&str, core::ops::Range<usize>)] = &[
    (r"Africa/Abidjan", 3982..4112),
    (r"Africa/Accra", 3982..4112),
    (r"Africa/Addis_Ababa", 12063..12254),
    (r"Africa/Algiers", 32218..32688),
    (r"Africa/Asmara", 12063..12254),
    (r"Africa/Asmera", 12063..12254),
    (r"Africa/Bamako", 3982..4112),
    (r"Africa/Bangui", 10414..10594),
    (r"Africa/Banjul", 3982..4112),
    (r"Africa/Bissau", 6252..6401),
    (r"Africa/Blantyre", 3851..3982),
    (r"Africa/Brazzaville", 10414..10594),
    (r"Africa/Bujumbura", 3851..3982),
    (r"Africa/Cairo", 163461..164770),
    (r"Africa/Casablanca", 189897..191818),
    (r"Africa/Ceuta", 41827..42389),
    (r"Africa/Conakry", 3982..4112),
    (r"Africa/Dakar", 3982..4112),
    (r"Africa/Dar_es_Salaam", 12063..12254),
    (r"Africa/Djibouti", 12063..12254),
    (r"Africa/Douala", 10414..10594),
    (r"Africa/El_Aaiun", 186193..188019),
    (r"Africa/Freetown", 3982..4112),
    (r"Africa/Gaborone", 3851..3982),
    (r"Africa/Harare", 3851..3982),
    (r"Africa/Johannesburg", 12455..12645),
    (r"Africa/Juba", 34105..34563),
    (r"Africa/Kampala", 12063..12254),
    (r"Africa/Khartoum", 33647..34105),
    (r"Africa/Kigali", 3851..3982),
    (r"Africa/Kinshasa", 10414..10594),
    (r"Africa/Lagos", 10414..10594),
    (r"Africa/Libreville", 10414..10594),
    (r"Africa/Lome", 3982..4112),
    (r"Africa/Luanda", 10414..10594),
    (r"Africa/Lubumbashi", 3851..3982),
    (r"Africa/Lusaka", 3851..3982),
    (r"Africa/Malabo", 10414..10594),
    (r"Africa/Maputo", 3851..3982),
    (r"Africa/Maseru", 12455..12645),
    (r"Africa/Mbabane", 12455..12645),
    (r"Africa/Mogadishu", 12063..12254),
    (r"Africa/Monrovia", 7800..7964),
    (r"Africa/Nairobi", 12063..12254),
    (r"Africa/Ndjamena", 7640..7800),
    (r"Africa/Niamey", 10414..10594),
    (r"Africa/Nouakchott", 3982..4112),
    (r"Africa/Ouagadougou", 3982..4112),
    (r"Africa/Porto-Novo", 10414..10594),
    (r"Africa/Sao_Tome", 8991..9164),
    (r"Africa/Timbuktu", 3982..4112),
    (r"Africa/Tripoli", 29570..30001),
    (r"Africa/Tunis", 31769..32218),
    (r"Africa/Windhoek", 56604..57257),
    (r"America/Adak", 122687..123656),
    (r"America/Anchorage", 124631..125608),
    (r"America/Anguilla", 9872..10049),
    (r"America/Antigua", 9872..10049),
    (r"America/Araguaina", 48346..48938),
    (r"America/Argentina/Buenos_Aires", 69732..70440),
    (r"America/Argentina/Catamarca", 71148..71856),
    (r"America/Argentina/ComodRivadavia", 71148..71856),
    (r"America/Argentina/Cordoba", 70440..71148),
    (r"America/Argentina/Jujuy", 61970..62660),
    (r"America/Argentina/La_Rioja", 76114..76831),
    (r"America/Argentina/Mendoza", 72564..73272),
    (r"America/Argentina/Rio_Gallegos", 73272..73980),
    (r"America/Argentina/Salta", 62660..63350),
    (r"America/Argentina/San_Juan", 76831..77548),
    (r"America/Argentina/San_Luis", 75397..76114),
    (r"America/Argentina/Tucuman", 77548..78274),
    (r"America/Argentina/Ushuaia", 71856..72564),
    (r"America/Aruba", 9872..10049),
    (r"America/Asuncion", 152557..153642),
    (r"America/Atikokan", 5647..5796),
    (r"America/Atka", 122687..123656),
    (r"America/Bahia", 65501..66183),
    (r"America/Bahia_Banderas", 68309..69009),
    (r"America/Barbados", 18004..18282),
    (r"America/Belem", 25854..26248),
    (r"America/Belize", 148225..149270),
    (r"America/Blanc-Sablon", 9872..10049),
    (r"America/Boa_Vista", 30001..30431),
    (r"America/Bogota", 9514..9693),
    (r"America/Boise", 136117..137116),
    (r"America/Buenos_Aires", 69732..70440),
    (r"America/Cambridge_Bay", 108992..109875),
    (r"America/Campo_Grande", 138068..139020),
    (r"America/Cancun", 41289..41827),
    (r"America/Caracas", 11873..12063),
    (r"America/Catamarca", 71148..71856),
    (r"America/Cayenne", 6101..6252),
    (r"America/Cayman", 5647..5796),
    (r"America/Chicago", 184439..186193),
    (r"America/Chihuahua", 64055..64746),
    (r"America/Ciudad_Juarez", 66873..67591),
    (r"America/Coral_Harbour", 5647..5796),
    (r"America/Cordoba", 70440..71148),
    (r"America/Costa_Rica", 16497..16729),
    (r"America/Coyhaique", 167472..168834),
    (r"America/Creston", 16966..17206),
    (r"America/Cuiaba", 132233..133167),
    (r"America/Curacao", 9872..10049),
    (r"America/Danmarkshavn", 31322..31769),
    (r"America/Dawson", 142041..143070),
    (r"America/Dawson_Creek", 61287..61970),
    (r"America/Denver", 147183..148225),
    (r"America/Detroit", 112560..113459),
    (r"America/Dominica", 9872..10049),
    (r"America/Edmonton", 133167..134137),
    (r"America/Eirunepe", 30431..30867),
    (r"America/El_Salvador", 11514..11690),
    (r"America/Ensenada", 149270..150349),
    (r"America/Fort_Nelson", 171698..173146),
    (r"America/Fort_Wayne", 36060..36591),
    (r"America/Fortaleza", 37559..38043),
    (r"America/Glace_Bay", 110783..111663),
    (r"America/Godthab", 191818..192783),
    (r"America/Goose_Bay", 176127..177707),
    (r"America/Grand_Turk", 108139..108992),
    (r"America/Grenada", 9872..10049),
    (r"America/Guadeloupe", 9872..10049),
    (r"America/Guatemala", 15573..15785),
    (r"America/Guayaquil", 9693..9872),
    (r"America/Guyana", 10594..10775),
    (r"America/Halifax", 179306..180978),
    (r"America/Havana", 153642..154759),
    (r"America/Hermosillo", 17472..17730),
    (r"America/Indiana/Indianapolis", 36060..36591),
    (r"America/Indiana/Knox", 139996..141012),
    (r"America/Indiana/Marengo", 40172..40739),
    (r"America/Indiana/Petersburg", 59950..60633),
    (r"America/Indiana/Tell_City", 35538..36060),
    (r"America/Indiana/Vevay", 20693..21062),
    (r"America/Indiana/Vincennes", 39614..40172),
    (r"America/Indiana/Winamac", 44132..44735),
    (r"America/Indianapolis", 36060..36591),
    (r"America/Inuvik", 105602..106419),
    (r"America/Iqaluit", 106419..107274),
    (r"America/Jamaica", 21737..22076),
    (r"America/Jujuy", 61970..62660),
    (r"America/Juneau", 120800..121766),
    (r"America/Kentucky/Louisville", 158397..159639),
    (r"America/Kentucky/Monticello", 131261..132233),
    (r"America/Knox_IN", 139996..141012),
    (r"America/Kralendijk", 9872..10049),
    (r"America/La_Paz", 7964..8134),
    (r"America/Lima", 18282..18565),
    (r"America/Los_Angeles", 160873..162167),
    (r"America/Louisville", 158397..159639),
    (r"America/Lower_Princes", 9872..10049),
    (r"America/Maceio", 38601..39103),
    (r"America/Managua", 18565..18860),
    (r"America/Manaus", 27862..28274),
    (r"America/Marigot", 9872..10049),
    (r"America/Martinique", 10049..10227),
    (r"America/Matamoros", 28692..29129),
    (r"America/Mazatlan", 66183..66873),
    (r"America/Mendoza", 72564..73272),
    (r"America/Menominee", 115250..116167),
    (r"America/Merida", 60633..61287),
    (r"America/Metlakatla", 42389..42975),
    (r"America/Mexico_City", 98432..99205),
    (r"America/Miquelon", 40739..41289),
    (r"America/Moncton", 174634..176127),
    (r"America/Monterrey", 74688..75397),
    (r"America/Montevideo", 128417..129386),
    (r"America/Montreal", 180978..182695),
    (r"America/Montserrat", 9872..10049),
    (r"America/Nassau", 180978..182695),
    (r"America/New_York", 182695..184439),
    (r"America/Nipigon", 180978..182695),
    (r"America/Nome", 123656..124631),
    (r"America/Noronha", 36591..37075),
    (r"America/North_Dakota/Beulah", 146140..147183),
    (r"America/North_Dakota/Center", 134137..135127),
    (r"America/North_Dakota/New_Salem", 135127..136117),
    (r"America/Nuuk", 191818..192783),
    (r"America/Ojinaga", 67591..68309),
    (r"America/Panama", 5647..5796),
    (r"America/Pangnirtung", 106419..107274),
    (r"America/Paramaribo", 10958..11145),
    (r"America/Phoenix", 16966..17206),
    (r"America/Port-au-Prince", 42975..43540),
    (r"America/Port_of_Spain", 9872..10049),
    (r"America/Porto_Acre", 28274..28692),
    (r"America/Porto_Velho", 26248..26642),
    (r"America/Puerto_Rico", 9872..10049),
    (r"America/Punta_Arenas", 157179..158397),
    (r"America/Rainy_River", 162167..163461),
    (r"America/Rankin_Inlet", 104795..105602),
    (r"America/Recife", 37075..37559),
    (r"America/Regina", 54642..55280),
    (r"America/Resolute", 103988..104795),
    (r"America/Rio_Branco", 28274..28692),
    (r"America/Rosario", 70440..71148),
    (r"America/Santa_Isabel", 149270..150349),
    (r"America/Santarem", 27453..27862),
    (r"America/Santiago", 196015..197369),
    (r"America/Santo_Domingo", 19436..19753),
    (r"America/Sao_Paulo", 137116..138068),
    (r"America/Scoresbysund", 192783..193767),
    (r"America/Shiprock", 147183..148225),
    (r"America/Sitka", 119844..120800),
    (r"America/St_Barthelemy", 9872..10049),
    (r"America/St_Johns", 188019..189897),
    (r"America/St_Kitts", 9872..10049),
    (r"America/St_Lucia", 9872..10049),
    (r"America/St_Thomas", 9872..10049),
    (r"America/St_Vincent", 9872..10049),
    (r"America/Swift_Current", 22418..22786),
    (r"America/Tegucigalpa", 13299..13493),
    (r"America/Thule", 30867..31322),
    (r"America/Thunder_Bay", 180978..182695),
    (r"America/Tijuana", 149270..150349),
    (r"America/Toronto", 180978..182695),
    (r"America/Tortola", 9872..10049),
    (r"America/Vancouver", 164770..166100),
    (r"America/Virgin", 9872..10049),
    (r"America/Whitehorse", 141012..142041),
    (r"America/Winnipeg", 162167..163461),
    (r"America/Yakutat", 118898..119844),
    (r"America/Yellowknife", 133167..134137),
    (r"Antarctica/Casey", 18860..19147),
    (r"Antarctica/Davis", 13493..13690),
    (r"Antarctica/DumontDUrville", 6705..6859),
    (r"Antarctica/Macquarie", 139020..139996),
    (r"Antarctica/Mawson", 6553..6705),
    (r"Antarctica/McMurdo", 145097..146140),
    (r"Antarctica/Palmer", 114363..115250),
    (r"Antarctica/Rothera", 3295..3427),
    (r"Antarctica/South_Pole", 145097..146140),
    (r"Antarctica/Syowa", 4777..4910),
    (r"Antarctica/Troll", 3427..3585),
    (r"Antarctica/Vostok", 8821..8991),
    (r"Arctic/Longyearbyen", 63350..64055),
    (r"Asia/Aden", 4777..4910),
    (r"Asia/Almaty", 50854..51472),
    (r"Asia/Amman", 130333..131261),
    (r"Asia/Anadyr", 83378..84121),
    (r"Asia/Aqtau", 47124..47730),
    (r"Asia/Aqtobe", 48938..49553),
    (r"Asia/Ashgabat", 24273..24648),
    (r"Asia/Ashkhabad", 24273..24648),
    (r"Asia/Atyrau", 47730..48346),
    (r"Asia/Baghdad", 55974..56604),
    (r"Asia/Bahrain", 6401..6553),
    (r"Asia/Baku", 88581..89325),
    (r"Asia/Bangkok", 5343..5495),
    (r"Asia/Barnaul", 94632..95385),
    (r"Asia/Beirut", 79009..79741),
    (r"Asia/Bishkek", 51472..52090),
    (r"Asia/Brunei", 19753..20073),
    (r"Asia/Calcutta", 13690..13910),
    (r"Asia/Chita", 89325..90075),
    (r"Asia/Choibalsan", 45936..46530),
    (r"Asia/Chongqing", 25461..25854),
    (r"Asia/Chungking", 25461..25854),
    (r"Asia/Colombo", 14362..14609),
    (r"Asia/Dacca", 14131..14362),
    (r"Asia/Damascus", 159639..160873),
    (r"Asia/Dhaka", 14131..14362),
    (r"Asia/Dili", 8651..8821),
    (r"Asia/Dubai", 4511..4644),
    (r"Asia/Dushanbe", 23152..23518),
    (r"Asia/Famagusta", 127477..128417),
    (r"Asia/Gaza", 197369..200319),
    (r"Asia/Harbin", 25461..25854),
    (r"Asia/Hebron", 200319..203287),
    (r"Asia/Ho_Chi_Minh", 15785..16021),
    (r"Asia/Hong_Kong", 100821..101596),
    (r"Asia/Hovd", 46530..47124),
    (r"Asia/Irkutsk", 91581..92341),
    (r"Asia/Istanbul", 154759..155959),
    (r"Asia/Jakarta", 14856..15104),
    (r"Asia/Jayapura", 8480..8651),
    (r"Asia/Jerusalem", 193767..194841),
    (r"Asia/Kabul", 6859..7018),
    (r"Asia/Kamchatka", 80467..81194),
    (r"Asia/Karachi", 17206..17472),
    (r"Asia/Kashgar", 4644..4777),
    (r"Asia/Kathmandu", 7479..7640),
    (r"Asia/Katmandu", 7479..7640),
    (r"Asia/Khandyga", 96891..97666),
    (r"Asia/Kolkata", 13690..13910),
    (r"Asia/Krasnoyarsk", 85603..86344),
    (r"Asia/Kuala_Lumpur", 15104..15360),
    (r"Asia/Kuching", 19753..20073),
    (r"Asia/Kuwait", 4777..4910),
    (r"Asia/Macao", 102385..103176),
    (r"Asia/Macau", 102385..103176),
    (r"Asia/Magadan", 90075..90826),
    (r"Asia/Makassar", 11145..11335),
    (r"Asia/Manila", 17730..18004),
    (r"Asia/Muscat", 4511..4644),
    (r"Asia/Nicosia", 44735..45332),
    (r"Asia/Novokuznetsk", 81194..81920),
    (r"Asia/Novosibirsk", 95385..96138),
    (r"Asia/Omsk", 84121..84862),
    (r"Asia/Oral", 49553..50178),
    (r"Asia/Phnom_Penh", 5343..5495),
    (r"Asia/Pontianak", 14609..14856),
    (r"Asia/Pyongyang", 11690..11873),
    (r"Asia/Qatar", 6401..6553),
    (r"Asia/Qostanay", 52714..53338),
    (r"Asia/Qyzylorda", 52090..52714),
    (r"Asia/Rangoon", 10227..10414),
    (r"Asia/Riyadh", 4777..4910),
    (r"Asia/Saigon", 15785..16021),
    (r"Asia/Sakhalin", 90826..91581),
    (r"Asia/Samarkand", 23518..23884),
    (r"Asia/Seoul", 27038..27453),
    (r"Asia/Shanghai", 25461..25854),
    (r"Asia/Singapore", 15104..15360),
    (r"Asia/Srednekolymsk", 87086..87828),
    (r"Asia/Taipei", 39103..39614),
    (r"Asia/Tashkent", 22786..23152),
    (r"Asia/Tbilisi", 53338..53967),
    (r"Asia/Tehran", 103176..103988),
    (r"Asia/Tel_Aviv", 193767..194841),
    (r"Asia/Thimbu", 7171..7325),
    (r"Asia/Thimphu", 7171..7325),
    (r"Asia/Tokyo", 15360..15573),
    (r"Asia/Tomsk", 96138..96891),
    (r"Asia/Ujung_Pandang", 11145..11335),
    (r"Asia/Ulaanbaatar", 45936..46530),
    (r"Asia/Ulan_Bator", 45936..46530),
    (r"Asia/Urumqi", 4644..4777),
    (r"Asia/Ust-Nera", 93861..94632),
    (r"Asia/Vientiane", 5343..5495),
    (r"Asia/Vladivostok", 86344..87086),
    (r"Asia/Yakutsk", 84862..85603),
    (r"Asia/Yangon", 10227..10414),
    (r"Asia/Yekaterinburg", 92341..93101),
    (r"Asia/Yerevan", 73980..74688),
    (r"Atlantic/Azores", 168834..170235),
    (r"Atlantic/Bermuda", 144073..145097),
    (r"Atlantic/Canary", 33169..33647),
    (r"Atlantic/Cape_Verde", 9164..9339),
    (r"Atlantic/Faeroe", 29129..29570),
    (r"Atlantic/Faroe", 29129..29570),
    (r"Atlantic/Jan_Mayen", 63350..64055),
    (r"Atlantic/Madeira", 166100..167472),
    (r"Atlantic/Reykjavik", 3982..4112),
    (r"Atlantic/South_Georgia", 3585..3717),
    (r"Atlantic/St_Helena", 3982..4112),
    (r"Atlantic/Stanley", 101596..102385),
    (r"Australia/ACT", 117090..117994),
    (r"Australia/Adelaide", 121766..122687),
    (r"Australia/Brisbane", 19147..19436),
    (r"Australia/Broken_Hill", 125608..126549),
    (r"Australia/Canberra", 117090..117994),
    (r"Australia/Currie", 143070..144073),
    (r"Australia/Darwin", 16263..16497),
    (r"Australia/Eucla", 20379..20693),
    (r"Australia/Hobart", 143070..144073),
    (r"Australia/LHI", 59258..59950),
    (r"Australia/Lindeman", 21062..21387),
    (r"Australia/Lord_Howe", 59258..59950),
    (r"Australia/Melbourne", 117994..118898),
    (r"Australia/North", 16263..16497),
    (r"Australia/NSW", 117090..117994),
    (r"Australia/Perth", 20073..20379),
    (r"Australia/Queensland", 19147..19436),
    (r"Australia/South", 121766..122687),
    (r"Australia/Sydney", 117090..117994),
    (r"Australia/Tasmania", 143070..144073),
    (r"Australia/Victoria", 117994..118898),
    (r"Australia/West", 20073..20379),
    (r"Australia/Yancowinna", 125608..126549),
    (r"Brazil/Acre", 28274..28692),
    (r"Brazil/DeNoronha", 36591..37075),
    (r"Brazil/East", 137116..138068),
    (r"Brazil/West", 27862..28274),
    (r"Canada/Atlantic", 179306..180978),
    (r"Canada/Central", 162167..163461),
    (r"Canada/Eastern", 180978..182695),
    (r"Canada/Mountain", 133167..134137),
    (r"Canada/Newfoundland", 188019..189897),
    (r"Canada/Pacific", 164770..166100),
    (r"Canada/Saskatchewan", 54642..55280),
    (r"Canada/Yukon", 141012..142041),
    (r"CET", 151454..152557),
    (r"Chile/Continental", 196015..197369),
    (r"Chile/EasterIsland", 194841..196015),
    (r"CST6CDT", 184439..186193),
    (r"Cuba", 153642..154759),
    (r"EET", 57918..58600),
    (r"Egypt", 163461..164770),
    (r"Eire", 173146..174634),
    (r"EST", 5647..5796),
    (r"EST5EDT", 182695..184439),
    (r"Etc/GMT", 113..224),
    (r"Etc/GMT+0", 113..224),
    (r"Etc/GMT+1", 3182..3295),
    (r"Etc/GMT+10", 2164..2278),
    (r"Etc/GMT+11", 2050..2164),
    (r"Etc/GMT+12", 1936..2050),
    (r"Etc/GMT+2", 3069..3182),
    (r"Etc/GMT+3", 2956..3069),
    (r"Etc/GMT+4", 2843..2956),
    (r"Etc/GMT+5", 2730..2843),
    (r"Etc/GMT+6", 2617..2730),
    (r"Etc/GMT+7", 2504..2617),
    (r"Etc/GMT+8", 2391..2504),
    (r"Etc/GMT+9", 2278..2391),
    (r"Etc/GMT-0", 113..224),
    (r"Etc/GMT-1", 335..449),
    (r"Etc/GMT-10", 1361..1476),
    (r"Etc/GMT-11", 1476..1591),
    (r"Etc/GMT-12", 1591..1706),
    (r"Etc/GMT-13", 1706..1821),
    (r"Etc/GMT-14", 1821..1936),
    (r"Etc/GMT-2", 449..563),
    (r"Etc/GMT-3", 563..677),
    (r"Etc/GMT-4", 677..791),
    (r"Etc/GMT-5", 791..905),
    (r"Etc/GMT-6", 905..1019),
    (r"Etc/GMT-7", 1019..1133),
    (r"Etc/GMT-8", 1133..1247),
    (r"Etc/GMT-9", 1247..1361),
    (r"Etc/GMT0", 113..224),
    (r"Etc/Greenwich", 113..224),
    (r"Etc/UCT", 224..335),
    (r"Etc/Universal", 224..335),
    (r"Etc/UTC", 224..335),
    (r"Etc/Zulu", 224..335),
    (r"Europe/Amsterdam", 151454..152557),
    (r"Europe/Andorra", 23884..24273),
    (r"Europe/Astrakhan", 81920..82646),
    (r"Europe/Athens", 57918..58600),
    (r"Europe/Belfast", 177707..179306),
    (r"Europe/Belgrade", 34563..35041),
    (r"Europe/Berlin", 63350..64055),
    (r"Europe/Bratislava", 69009..69732),
    (r"Europe/Brussels", 151454..152557),
    (r"Europe/Bucharest", 57257..57918),
    (r"Europe/Budapest", 97666..98432),
    (r"Europe/Busingen", 35041..35538),
    (r"Europe/Chisinau", 64746..65501),
    (r"Europe/Copenhagen", 63350..64055),
    (r"Europe/Dublin", 173146..174634),
    (r"Europe/Gibraltar", 155959..157179),
    (r"Europe/Guernsey", 177707..179306),
    (r"Europe/Helsinki", 32688..33169),
    (r"Europe/Isle_of_Man", 177707..179306),
    (r"Europe/Istanbul", 154759..155959),
    (r"Europe/Jersey", 177707..179306),
    (r"Europe/Kaliningrad", 113459..114363),
    (r"Europe/Kiev", 38043..38601),
    (r"Europe/Kirov", 78274..79009),
    (r"Europe/Kyiv", 38043..38601),
    (r"Europe/Lisbon", 170235..171698),
    (r"Europe/Ljubljana", 34563..35041),
    (r"Europe/London", 177707..179306),
    (r"Europe/Luxembourg", 151454..152557),
    (r"Europe/Madrid", 111663..112560),
    (r"Europe/Malta", 126549..127477),
    (r"Europe/Mariehamn", 32688..33169),
    (r"Europe/Minsk", 99205..100013),
    (r"Europe/Monaco", 150349..151454),
    (r"Europe/Moscow", 109875..110783),
    (r"Europe/Nicosia", 44735..45332),
    (r"Europe/Oslo", 63350..64055),
    (r"Europe/Paris", 150349..151454),
    (r"Europe/Podgorica", 34563..35041),
    (r"Europe/Prague", 69009..69732),
    (r"Europe/Riga", 55280..55974),
    (r"Europe/Rome", 129386..130333),
    (r"Europe/Samara", 82646..83378),
    (r"Europe/San_Marino", 129386..130333),
    (r"Europe/Sarajevo", 34563..35041),
    (r"Europe/Saratov", 79741..80467),
    (r"Europe/Simferopol", 107274..108139),
    (r"Europe/Skopje", 34563..35041),
    (r"Europe/Sofia", 43540..44132),
    (r"Europe/Stockholm", 63350..64055),
    (r"Europe/Tallinn", 53967..54642),
    (r"Europe/Tirane", 45332..45936),
    (r"Europe/Tiraspol", 64746..65501),
    (r"Europe/Ulyanovsk", 93101..93861),
    (r"Europe/Uzhgorod", 38043..38601),
    (r"Europe/Vaduz", 35041..35538),
    (r"Europe/Vatican", 129386..130333),
    (r"Europe/Vienna", 58600..59258),
    (r"Europe/Vilnius", 50178..50854),
    (r"Europe/Volgograd", 87828..88581),
    (r"Europe/Warsaw", 116167..117090),
    (r"Europe/Zagreb", 34563..35041),
    (r"Europe/Zaporozhye", 38043..38601),
    (r"Europe/Zurich", 35041..35538),
    (r"Factory", 0..113),
    (r"GB", 177707..179306),
    (r"GB-Eire", 177707..179306),
    (r"GMT", 113..224),
    (r"GMT+0", 113..224),
    (r"GMT-0", 113..224),
    (r"GMT0", 113..224),
    (r"Greenwich", 113..224),
    (r"Hongkong", 100821..101596),
    (r"HST", 13910..14131),
    (r"Iceland", 3982..4112),
    (r"Indian/Antananarivo", 12063..12254),
    (r"Indian/Chagos", 5949..6101),
    (r"Indian/Christmas", 5343..5495),
    (r"Indian/Cocos", 10227..10414),
    (r"Indian/Comoro", 12063..12254),
    (r"Indian/Kerguelen", 5495..5647),
    (r"Indian/Mahe", 4511..4644),
    (r"Indian/Maldives", 5495..5647),
    (r"Indian/Mauritius", 11335..11514),
    (r"Indian/Mayotte", 12063..12254),
    (r"Indian/Reunion", 4511..4644),
    (r"Iran", 103176..103988),
    (r"Israel", 193767..194841),
    (r"Jamaica", 21737..22076),
    (r"Japan", 15360..15573),
    (r"Kwajalein", 12882..13101),
    (r"Libya", 29570..30001),
    (r"MET", 151454..152557),
    (r"Mexico/BajaNorte", 149270..150349),
    (r"Mexico/BajaSur", 66183..66873),
    (r"Mexico/General", 98432..99205),
    (r"MST", 16966..17206),
    (r"MST7MDT", 147183..148225),
    (r"Navajo", 147183..148225),
    (r"NZ", 145097..146140),
    (r"NZ-CHAT", 100013..100821),
    (r"Pacific/Apia", 24648..25055),
    (r"Pacific/Auckland", 145097..146140),
    (r"Pacific/Bougainville", 12254..12455),
    (r"Pacific/Chatham", 100013..100821),
    (r"Pacific/Chuuk", 6705..6859),
    (r"Pacific/Easter", 194841..196015),
    (r"Pacific/Efate", 22076..22418),
    (r"Pacific/Enderbury", 8134..8306),
    (r"Pacific/Fakaofo", 5796..5949),
    (r"Pacific/Fiji", 26642..27038),
    (r"Pacific/Funafuti", 3717..3851),
    (r"Pacific/Galapagos", 9339..9514),
    (r"Pacific/Gambier", 4246..4378),
    (r"Pacific/Guadalcanal", 4112..4246),
    (r"Pacific/Guam", 21387..21737),
    (r"Pacific/Honolulu", 13910..14131),
    (r"Pacific/Johnston", 13910..14131),
    (r"Pacific/Kanton", 8134..8306),
    (r"Pacific/Kiritimati", 8306..8480),
    (r"Pacific/Kosrae", 16021..16263),
    (r"Pacific/Kwajalein", 12882..13101),
    (r"Pacific/Majuro", 3717..3851),
    (r"Pacific/Marquesas", 4910..5049),
    (r"Pacific/Midway", 5197..5343),
    (r"Pacific/Nauru", 10775..10958),
    (r"Pacific/Niue", 7325..7479),
    (r"Pacific/Norfolk", 12645..12882),
    (r"Pacific/Noumea", 13101..13299),
    (r"Pacific/Pago_Pago", 5197..5343),
    (r"Pacific/Palau", 5049..5197),
    (r"Pacific/Pitcairn", 7018..7171),
    (r"Pacific/Pohnpei", 4112..4246),
    (r"Pacific/Ponape", 4112..4246),
    (r"Pacific/Port_Moresby", 6705..6859),
    (r"Pacific/Rarotonga", 25055..25461),
    (r"Pacific/Saipan", 21387..21737),
    (r"Pacific/Samoa", 5197..5343),
    (r"Pacific/Tahiti", 4378..4511),
    (r"Pacific/Tarawa", 3717..3851),
    (r"Pacific/Tongatapu", 16729..16966),
    (r"Pacific/Truk", 6705..6859),
    (r"Pacific/Wake", 3717..3851),
    (r"Pacific/Wallis", 3717..3851),
    (r"Pacific/Yap", 6705..6859),
    (r"Poland", 116167..117090),
    (r"Portugal", 170235..171698),
    (r"PRC", 25461..25854),
    (r"PST8PDT", 160873..162167),
    (r"ROC", 39103..39614),
    (r"ROK", 27038..27453),
    (r"Singapore", 15104..15360),
    (r"Turkey", 154759..155959),
    (r"UCT", 224..335),
    (r"Universal", 224..335),
    (r"US/Alaska", 124631..125608),
    (r"US/Aleutian", 122687..123656),
    (r"US/Arizona", 16966..17206),
    (r"US/Central", 184439..186193),
    (r"US/East-Indiana", 36060..36591),
    (r"US/Eastern", 182695..184439),
    (r"US/Hawaii", 13910..14131),
    (r"US/Indiana-Starke", 139996..141012),
    (r"US/Michigan", 112560..113459),
    (r"US/Mountain", 147183..148225),
    (r"US/Pacific", 160873..162167),
    (r"US/Samoa", 5197..5343),
    (r"UTC", 224..335),
    (r"W-SU", 109875..110783),
    (r"WET", 170235..171698),
    (r"Zulu", 224..335),
];
